guiDraw = {};

function guiDraw:open(self)
	g_currentMission.guiMenue.clickAreas = {};
	if g_currentMission.guiMenue.on then		
		guiDraw:resetColorButtons(self);
		local isOpenDownUpLine = false;
		local overlay = g_currentMission.guiMenue.overlays;
		local width = g_currentMission.guiMenue.default.width;
		local height = g_currentMission.guiMenue.default.height;
		local iconHeight = g_currentMission.guiMenue.default.iconHeight;
		local iconWidth = g_currentMission.guiMenue.default.iconWidth;
		local posX = g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2)+iconWidth;
		local posY = g_currentMission.guiMenue.default.posY-(iconHeight*2);
		local lastPosY = posY;
		local txt = "";
		local infoTxt = "";
		setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
		overlay["guiGroundT"]:render();
		guiSetGet:setOverlay(overlay["guiLineT"], g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2), g_currentMission.guiMenue.default.posY-iconHeight, false, false);
		overlay["guiLineT"]:render();
		overlay["guiSettings"]:render();
		local noSaveSettings = 0;
		local noSaveSettingsColor = "green";
		for key, value in pairs (g_currentMission.guiMenue.mod) do		
			if g_currentMission.guiMenue.mod[key].tempSave then noSaveSettings = noSaveSettings+1;end;
		end;
		txt = "Close Menue(no save)";
		if noSaveSettings > 0 then noSaveSettingsColor = "red";infoTxt=tostring(noSaveSettings).. "x Menue Settings not Saved";txt = "Close Menue(!! Save Warrning !!)";end;
		guiDraw:setClickAreas(overlay["guiSettings"].x, overlay["guiSettings"].x+g_currentMission.guiMenue.default.iconWidth, overlay["guiSettings"].y, overlay["guiSettings"].y+g_currentMission.guiMenue.default.iconHeight, "closeMenue", tostring(txt), tostring(infoTxt), true, 0.012, nil, true, tostring(noSaveSettingsColor), overlay["guiSettings"].width, overlay["guiSettings"].height, "guiSettings");
				
		local modMenueName = nil;
		if g_currentMission.guiMenue.modMenueTable ~= nil and #g_currentMission.guiMenue.modMenueTable > 0 then
			if g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue] ~= nil then			
				txt = g_currentMission.guiMenue.mod[g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue]].settingsName;
				modMenueName = g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue];			
			end;
		end;
		if modMenueName == nil then
			txt = "GUI Menue for Mod !! not Found !!";
			setTextColor(unpack(g_currentMission.guiMenue.default.textWarningColor));
		end;
		setTextAlignment(1);
		setTextBold(true);		
		renderText(g_currentMission.guiMenue.default.posX, g_currentMission.guiMenue.default.posY-(iconHeight)+(iconHeight/3), g_currentMission.guiMenue.default.size+0.003, tostring(txt));
		renderText(g_currentMission.guiMenue.default.posX+(g_currentMission.guiMenue.default.width/2)-(iconWidth*5), g_currentMission.guiMenue.default.posY-(iconHeight)+(iconHeight/3), g_currentMission.guiMenue.default.size+0.003, tostring(g_currentMission.guiMenue.modMenue).. "/".. tostring(#g_currentMission.guiMenue.modMenueTable));
		txt = g_currentMission.guiMenue.mod[g_currentMission.guiMenue.modMenueTable[g_currentMission.guiMenue.modMenue]].modVersion;
		renderText(g_currentMission.guiMenue.default.posX, g_currentMission.guiMenue.default.posY-(iconHeight), g_currentMission.guiMenue.default.size-0.002, tostring(txt));
		
		setTextAlignment(0);
		setTextBold(false);
		if #g_currentMission.guiMenue.modMenueTable > 1 then
			--guiSetGet:setBackgroundColor(overlay["buttonGround"], g_currentMission.guiMenue.default.buttonGroundColor);
			guiSetGet:setOverlay(overlay["arrowLeft"], g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2)+(iconWidth*2), g_currentMission.guiMenue.default.posY-(iconHeight), iconWidth, iconHeight);
			--guiSetGet:setOverlay(overlay["buttonGround"], g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2)+(iconWidth*2), g_currentMission.guiMenue.default.posY-(iconHeight), iconWidth, iconHeight);
			--overlay["buttonGround"]:render();
			overlay["arrowLeft"]:render();
			txt = "Next Mod Menue";
			guiDraw:setClickAreas(overlay["arrowLeft"].x, overlay["arrowLeft"].x+g_currentMission.guiMenue.default.iconWidth, overlay["arrowLeft"].y, overlay["arrowLeft"].y+g_currentMission.guiMenue.default.iconHeight, "nextModMenueLeft", tostring(txt), "", true, nil, nil, true, "yellow", overlay["arrowLeft"].width, overlay["arrowLeft"].height, "arrowLeft");
			guiSetGet:setOverlay(overlay["arrowRight"], g_currentMission.guiMenue.default.posX+(g_currentMission.guiMenue.default.width/2)-(iconWidth*3), g_currentMission.guiMenue.default.posY-(iconHeight), iconWidth, iconHeight);
			--guiSetGet:setOverlay(overlay["buttonGround"], g_currentMission.guiMenue.default.posX+(g_currentMission.guiMenue.default.width/2)-(iconWidth*3), g_currentMission.guiMenue.default.posY-(iconHeight), iconWidth, iconHeight);
			--guiSetGet:setBackgroundColor(overlay["arrowLeft"], guiSetGet.colors["green"]);
			--overlay["buttonGround"]:render();			
			overlay["arrowRight"]:render();
			guiDraw:setClickAreas(overlay["arrowRight"].x, overlay["arrowRight"].x+g_currentMission.guiMenue.default.iconWidth, overlay["arrowRight"].y, overlay["arrowRight"].y+g_currentMission.guiMenue.default.iconHeight, "nextModMenueRight", tostring(txt), "", true, nil, nil, true, "yellow", overlay["arrowRight"].width, overlay["arrowRight"].height, "arrowRight");
		end;
		if modMenueName ~= nil then
			txt = "Save Settings (".. tostring(g_currentMission.guiMenue.mod[modMenueName].settingsName).. ")";
			if g_currentMission.guiMenue.mod[modMenueName].tempSave then
				guiSetGet:setBackgroundColor(overlay["saveButton"], guiSetGet.colors["red"]);
			else
				guiSetGet:setBackgroundColor(overlay["saveButton"], guiSetGet.colors["green"]);
			end;
		else
			txt = "Save Settings (not found Mod Gui Menue)";
		end;
		overlay["saveButton"]:render();
		guiDraw:setClickAreas(overlay["saveButton"].x, overlay["saveButton"].x+g_currentMission.guiMenue.default.iconWidth, overlay["saveButton"].y, overlay["saveButton"].y+g_currentMission.guiMenue.default.iconHeight, "saveButton", tostring(txt), "", true, nil, nil, true, "yellow", overlay["saveButton"].width, overlay["saveButton"].height, "saveButton");
		
		if modMenueName ~= nil and g_currentMission.guiMenue.mod[modMenueName].page[g_currentMission.guiMenue.mod[modMenueName].lastPage] ~= nil then
			local pageTable = g_currentMission.guiMenue.mod[modMenueName].page[g_currentMission.guiMenue.mod[modMenueName].lastPage];
			txt = pageTable.pageName;
			setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
			setTextAlignment(1);
			setTextBold(true);			
			renderText(g_currentMission.guiMenue.default.posX, g_currentMission.guiMenue.default.posY-(iconHeight*2)+(iconHeight/3), g_currentMission.guiMenue.default.size+0.003, tostring(txt));
			renderText(g_currentMission.guiMenue.default.posX+(g_currentMission.guiMenue.default.width/2)-(iconWidth*5), g_currentMission.guiMenue.default.posY-(iconHeight*2)+(iconHeight/3), g_currentMission.guiMenue.default.size+0.003, tostring(g_currentMission.guiMenue.mod[modMenueName].lastPage).. "/".. tostring(#g_currentMission.guiMenue.mod[modMenueName].page));
			setTextAlignment(0);
			setTextBold(false);
			guiSetGet:setOverlay(overlay["guiLineT"], g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2), g_currentMission.guiMenue.default.posY-(iconHeight*2), false, false);
			overlay["guiLineT"]:render();
			if #g_currentMission.guiMenue.mod[modMenueName].page > 1 then				
				guiSetGet:setOverlay(overlay["arrowLeft"], g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2)+(iconWidth*2), g_currentMission.guiMenue.default.posY-(iconHeight*2), iconWidth, iconHeight);
				overlay["arrowLeft"]:render();
				txt = "Next Page";
				guiDraw:setClickAreas(overlay["arrowLeft"].x, overlay["arrowLeft"].x+g_currentMission.guiMenue.default.iconWidth, overlay["arrowLeft"].y, overlay["arrowLeft"].y+g_currentMission.guiMenue.default.iconHeight, "nextPageLeft", tostring(txt), "", true, nil, nil, true, "yellow", overlay["arrowLeft"].width, overlay["arrowLeft"].height, "arrowLeft");
				guiSetGet:setOverlay(overlay["arrowRight"], g_currentMission.guiMenue.default.posX+(g_currentMission.guiMenue.default.width/2)-(iconWidth*3), g_currentMission.guiMenue.default.posY-(iconHeight*2), iconWidth, iconHeight);
				overlay["arrowRight"]:render();
				guiDraw:setClickAreas(overlay["arrowRight"].x, overlay["arrowRight"].x+g_currentMission.guiMenue.default.iconWidth, overlay["arrowRight"].y, overlay["arrowRight"].y+g_currentMission.guiMenue.default.iconHeight, "nextPageRight", tostring(txt), "", true, nil, nil, true, "yellow", overlay["arrowRight"].width, overlay["arrowRight"].height, "arrowRight");
			end;
			--setPageButtons
			local buttons = pageTable.buttons;
			local cancelNextLine = false;
			if buttons ~= nil then				
				local nextPosY = 0;	
				local newPosY = g_currentMission.guiMenue.default.posY-(iconHeight*3);
				local overTextDistance = 0.005;
				for line=1, #buttons do	
					if buttons[line] ~= nil and not cancelNextLine then						
						--test string
						--setTextAlignment(1);
						--renderText(g_currentMission.guiMenue.default.posX-(width/2), g_currentMission.guiMenue.default.posY-(iconHeight*3), pageTable.size, tostring("Test Text"));
						--setTextAlignment(0);
						--test string
						local overTextHeight = 0;						
						local distanceLine = tonumber(buttons[line].distanceLine);
						if buttons[line].overButtonText then overTextHeight = getTextHeight(pageTable.size, tostring("----Test----"));else overTextDistance=0;end;
						posX = g_currentMission.guiMenue.default.posX-(width/2);						
						posY = g_currentMission.guiMenue.default.posY-(iconHeight*(2+line))-distanceLine-nextPosY;						
						newPosY = newPosY-distanceLine-overTextHeight-overTextDistance;
						nextPosY = 0;
						local distanceFix = tonumber(buttons[line].distanceButtons/2);
						local size = pageTable.size;
						local maxButtons = buttons[line].maxButtons;						
						local buttonsPosX = guiDraw:getButtonsPosX(posX, width, maxButtons, tonumber(buttons[line].distanceButtons));
						for button=1, maxButtons do
							local drawButton = buttons[line][button];							
							local overlayType = g_currentMission.guiMenue.default.buttonsTypes[drawButton.buttonType];
							--print("overlayType...".. tostring(button).. " ".. tostring(overlayType))
							if overlayType ~= nil and not string.find(tostring(overlayType), "hidden") then
								local openDownUpText = false;								
								if drawButton.openDownUpText then openDownUpText = true;end;
								txt = tostring(drawButton.textOverButton);													
								if pageTable.optiSize then 
									size=guiDraw:getOptimalSize(buttonsPosX[button].width-distanceFix, txt, pageTable.size);
								else
									txt = guiDraw:getMaxTextWidth(buttonsPosX[button].width, txt, size);
								end;
								setTextBold(pageTable.txtBold);
								setTextColor(unpack(drawButton.textOverColor));
								renderText(buttonsPosX[button].posX, newPosY+iconHeight+overTextDistance, size, tostring(txt));
								setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
								setTextBold(false);
								txt = "";
								local doubleIcon = 0;
								local overlayName = tostring(overlayType);								
								if string.find(overlayType, "Double") then doubleIcon = iconWidth;overlayName = string.gsub(tostring(overlayType), "Double", "");end;
								guiSetGet:setOverlay(overlay[overlayName], buttonsPosX[button].posX, newPosY, iconWidth, iconHeight);								
								overlay[overlayName]:render();
								guiDraw:setClickAreas(overlay[overlayName].x, overlay[overlayName].x+iconWidth, overlay[overlayName].y, overlay[overlayName].y+iconHeight, tostring(overlayName), tostring(drawButton.helpText), tostring(drawButton.infoText), false, pageTable.helpSize, pageTable.infoSize, true, "yellow", overlay[overlayName].width, overlay[overlayName].height, tostring(overlayName), pageTable.pageNumber, line, button, 1, nil, openDownUpText);
								guiSetGet:setOverlay(overlay["buttonGroundT"], buttonsPosX[button].posX+iconWidth, newPosY, buttonsPosX[button].width-iconWidth-doubleIcon, iconHeight);
								overlay["buttonGroundT"]:render();
								if doubleIcon > 0 then
									local buttonDouble = 1;
									if string.find(tostring(overlayType), "Left") then overlayName = string.gsub(tostring(overlayName), "Left", "Right"); -- overlayName = "arrowRight";
									elseif string.find(tostring(overlayType), "Right") then overlayName = string.gsub(tostring(overlayName), "Right", "Left");buttonDouble=2;end; --overlayName = "arrowLeft";buttonDouble=2;end;
									guiSetGet:setOverlay(overlay[overlayName], buttonsPosX[button].posX+buttonsPosX[button].width-iconWidth, newPosY, iconWidth, iconHeight);
									overlay[overlayName]:render();
									guiDraw:setClickAreas(overlay[overlayName].x, overlay[overlayName].x+iconWidth, overlay[overlayName].y, overlay[overlayName].y+iconHeight, tostring(overlayName), tostring(drawButton.helpText), tostring(drawButton.infoText), false, pageTable.helpSize, pageTable.infoSize, true, "yellow", overlay[overlayName].width, overlay[overlayName].height, tostring(overlayName), pageTable.pageNumber, line, button, 2, nil, openDownUpText);
								end;
								if string.find(drawButton.buttonCmdType, "stringOnly") then
									txt = tostring(drawButton.buttonCmdTableValue);
								elseif string.find(drawButton.buttonCmdType, "string") or string.find(drawButton.buttonCmdType, "unknown") then 
									txt = tostring(drawButton.buttonCmdTable[drawButton.buttonCmdTableValue]);
								elseif string.find(drawButton.buttonCmdType, "boolean") then
									if Utils.getNoNil(drawButton.buttonCmdTable[drawButton.buttonCmdTableValue], false) then txt = "ON";else txt="OFF";end;
								elseif tonumber(drawButton.buttonCmdType) then
									txt = string.format("%".. tostring(drawButton.buttonCmdType).. "f", "".. tonumber(drawButton.buttonCmdTable[drawButton.buttonCmdTableValue]));								
								elseif string.find(drawButton.buttonCmdType, "money") then
									local tempCommand = drawButton.buttonCmdTable[drawButton.buttonCmdTableValue];									
									--local tempCommand = guiDraw:getCommand(drawButton.buttonCmdValues);									
									txt = g_i18n:formatMoney(tempCommand);		
								end;
								setTextBold(true);
								setTextAlignment(1);
								local tempIconWidth = iconWidth;
								if doubleIcon == 0 then tempIconWidth = 0;end;
								if pageTable.optiSize then size=guiDraw:getOptimalSize(buttonsPosX[button].width-(iconWidth-tempIconWidth-distanceFix), txt, pageTable.size+0.002);end;								
								renderText(buttonsPosX[button].posX+tempIconWidth+(buttonsPosX[button].width/2)-doubleIcon, newPosY+(iconHeight/4), size, tostring(txt));
								setTextBold(false);
								setTextAlignment(0);
								if openDownUpText and pageTable.openDownUpText and pageTable.openDownUpLine == line and not isOpenDownUpLine then																		
									isOpenDownUpLine = true;
									local nextDownUpText = 1;									
									local iconHeightTemp = 0;
									for key,value in pairs(drawButton.openDownUpText) do										
									--for a = 1, #drawButton.openDownUpText do										
										txt = tostring(drawButton.openDownUpText[key]);										
										size = drawButton.openDownUpTextSize;
										if pageTable.optiSize then size=guiDraw:getOptimalSize(buttonsPosX[button].width-iconWidth-distanceFix, txt, drawButton.openDownUpTextSize+0.002);end;
										local distanceFix = 0.002;
										iconHeightTemp = getTextHeight(size+distanceFix, tostring(txt));--iconHeight;
										local iconWidthTemp = iconHeightTemp-distanceFix;--iconWidth;
										if string.find(tostring(overlayType), "Down") then
											guiSetGet:setOverlay(overlay["buttonGround"], buttonsPosX[button].posX+iconWidth, newPosY-(iconHeightTemp*nextDownUpText), buttonsPosX[button].width-iconWidthTemp-doubleIcon, iconHeightTemp);
											overlay["buttonGround"]:render();
											renderText(buttonsPosX[button].posX+(iconWidth)+iconWidthTemp, newPosY-(iconHeightTemp*nextDownUpText)+(iconHeightTemp/4), size, tostring(txt));
											if drawButton.buttonCmdTable[key] then
												guiSetGet:setOverlay(overlay["okay"], buttonsPosX[button].posX+iconWidth, newPosY-(iconHeightTemp*nextDownUpText), iconWidthTemp, iconHeightTemp);
												overlay["okay"]:render();
											end;
											guiDraw:setClickAreas(overlay["buttonGround"].x, overlay["buttonGround"].x+overlay["buttonGround"].width, overlay["buttonGround"].y, overlay["buttonGround"].y+iconHeightTemp, tostring("buttonGround"), "", "", false, pageTable.helpSize, pageTable.infoSize, true, "greenMatt", overlay["buttonGround"].width, overlay["buttonGround"].height, tostring("buttonGround"), pageTable.pageNumber, line, button, 1, key, openDownUpText);
										else
											guiSetGet:setOverlay(overlay["buttonGround"], buttonsPosX[button].posX+iconWidth, newPosY+(iconHeightTemp*nextDownUpText), buttonsPosX[button].width-iconWidthTemp-doubleIcon, iconHeightTemp);
											overlay["buttonGround"]:render();
											renderText(buttonsPosX[button].posX+(iconWidth)+iconWidthTemp, newPosY+(iconHeightTemp*nextDownUpText)+(iconHeightTemp/4), size, tostring(txt));
											if drawButton.buttonCmdTable[key] then
												guiSetGet:setOverlay(overlay["okay"], buttonsPosX[button].posX+iconWidth, newPosY+(iconHeightTemp*nextDownUpText), iconWidthTemp, iconHeightTemp);
												overlay["okay"]:render();
											end;
										end;										
										nextDownUpText = nextDownUpText+1;										
									end;
									cancelNextLine = true;
									lastPosY = newPosY-(iconHeightTemp*nextDownUpText);
									--if string.find(tostring(overlayType), "Down") then
									--	guiSetGet:setOverlay(overlay["buttonGround"], buttonsPosX[button].posX+iconWidth, newPosY-(iconHeight*nextDownUpText), buttonsPosX[button].width-iconWidth-doubleIcon, iconHeight*nextDownUpText);
									--else
									--	guiSetGet:setOverlay(overlay["buttonGround"], buttonsPosX[button].posX+iconWidth, newPosY+iconHeight, buttonsPosX[button].width-iconWidth-doubleIcon, iconHeight*nextDownUpText);
									--end;
								end;
							end;
						end;
						newPosY = newPosY-iconHeight;
						if not cancelNextLine then lastPosY = newPosY;end;
					else
						newPosY = newPosY-iconHeight;
						if not cancelNextLine then lastPosY = newPosY;end;
					end;
				end;
				g_currentMission.guiMenue.default.lastPosY = lastPosY-(iconHeight/2);
			end;
		end;		
		if g_currentMission.guiMenue.default.posY-(overlay["guiGroundT"].height)+0.002 > g_currentMission.guiMenue.default.lastPosY then guiDraw:fix4K(self);end;
		--copyright
		setTextAlignment(1);
		--if string.len(g_currentMission.guiMenue.infoText.txt) <= 0 then
			setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
			txt = guiMenue.metadata.title.. guiMenue.metadata.version.. guiMenue.metadata.author;
			--renderText(g_currentMission.guiMenue.default.posX, g_currentMission.guiMenue.default.posY-(overlay["guiGroundT"].height)+0.002, g_currentMission.guiMenue.default.size-0.002, tostring(txt));
			renderText(g_currentMission.guiMenue.default.posX, g_currentMission.guiMenue.default.posY+0.002, g_currentMission.guiMenue.default.size-0.002, tostring(txt));
		--end;
		setTextAlignment(0);
		--copyright
	end;
end;

function guiDraw:fix4K(self)
	local overlay = g_currentMission.guiMenue.overlays;
	local posY = g_currentMission.guiMenue.default.posY-(g_currentMission.guiMenue.default.height);	
	local height = overlay["guiGroundT"].height;
	while posY > g_currentMission.guiMenue.default.lastPosY do
		posY = posY-g_currentMission.guiMenue.default.iconHeight;
		guiSetGet:setOverlay(overlay["guiGroundT"], false, posY, false, height+g_currentMission.guiMenue.default.iconHeight);
	end;
end;

function guiDraw:getButtonsPosX(posX, width, maxButtons, distance)
	local tablePosX = {};
	--local distance = 0.005;
	local buttonWidth = width/maxButtons;
	for a=1, maxButtons do
		tablePosX[a] = {};
		tablePosX[a].posX = posX+(buttonWidth*(a-1))+distance;
		if a == maxButtons then distance = distance*2;end;
		tablePosX[a].width = buttonWidth-distance;
	end;
	return tablePosX;
end;

function guiDraw:getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function guiDraw:getMaxTextWidth(buttonWidth, txtString, size)
	local txtWidth = getTextWidth(size, tostring(txtString));	
	local txtLenght = string.len(txtString);	
	if txtWidth > buttonWidth then
		local i = 0;
		while txtWidth > buttonWidth do
			i = i + 1;
			txtWidth = getTextWidth(size, tostring(utf8Substr(txtString, 0, txtLenght-i)));			
		end;	
		return utf8Substr(txtString, 0, txtLenght-2-i).. tostring("..");		
	end;
	return utf8Substr(txtString, 0, txtLenght);	
end;

function guiDraw:resetColorButtons(self)	
	local overlay = g_currentMission.guiMenue.overlays;
	guiSetGet:setBackgroundColor(overlay["arrowRight"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["arrowLeft"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["arrowDown"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["arrowUp"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["roundRight"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["roundLeft"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["halfRoundRight"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["halfRoundLeft"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["roundMultiple"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["roundButton"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["saveButton"], guiSetGet.colors["gray"]);
	guiSetGet:setBackgroundColor(overlay["guiSettings"], guiSetGet.colors["white"]);
	guiSetGet:setBackgroundColor(overlay["buttonGroundT"], g_currentMission.guiMenue.default.buttonGroundColor);
	guiSetGet:setBackgroundColor(overlay["buttonGround"], g_currentMission.guiMenue.default.groundColor);
end;

function guiDraw:setClickAreas(x, x1, y, y1, whatClick, helpText, infoText, isGuiText, helpSize, infoSize, markerColor, colorName, markerColorWidth, markerColorHeight, overlayName, page, line, button, buttonDouble, openDownUpLineString, isOpenDownUp)
	g_currentMission.guiMenue.clickAreas[#g_currentMission.guiMenue.clickAreas+1] = {
		x; 
		x1;
		y;
		y1;
		whatClick = whatClick;
		getHelpText = tostring(helpText);
		getInfoText = tostring(infoText);
		isGuiText = isGuiText;
		infoSize = infoSize;
		helpSize = helpSize;
		markerColor = markerColor;
		colorName = tostring(colorName);
		markerColorWidth = markerColorWidth;
		markerColorHeight = markerColorHeight;
		overlayName = tostring(overlayName);
		--{line=0,button=0,buttonDouble=0,openDownUpLineString=0}
		page = page;
		line = Utils.getNoNil(line, 0);
		button = Utils.getNoNil(button, 0);
		buttonDouble = Utils.getNoNil(buttonDouble, 0);
		isOpenDownUp = Utils.getNoNil(isOpenDownUp, false);
		openDownUpLineString = Utils.getNoNil(openDownUpLineString, "");
	};
end;

